
(* This file was originally generated by why.
   It can be modified; only the generated parts will be overwritten. *)

Require Export Krak_spec_why.
Load "local_tactics".

Set Implicit Arguments.

(*Why logic*) Definition Zlcompl : Z -> Z.
Admitted.

(*Why logic*) Definition Zland : Z -> Z -> Z.
Admitted.

(*Why logic*) Definition Zlor : Z -> Z -> Z.
Admitted.

(*Why logic*) Definition Zlsr : Z -> Z -> Z.
Admitted.

(*Why logic*) Definition Zasr : Z -> Z -> Z.
Admitted.

(*Why logic*) Definition Zlsl : Z -> Z -> Z.
Admitted.

(*Why logic*) Definition Zlxor : Z -> Z -> Z.
Admitted.

(*Why logic*) Definition andb : bool -> bool -> bool.
Admitted.

(*Why logic*) Definition orb : bool -> bool -> bool.
Admitted.

(*Why logic*) Definition negb : bool -> bool.
Admitted.

(*Why type*) Definition value: Set.
exact DummyObj.value.
Defined.

(*Why type*) Definition classId: Set.
exact DummyClasses.classId.
Defined.

(*Why type*) Definition javaType: Set.
exact DummyGen.javaType.
Defined.

(*Why logic*) Definition ArrIntType : javaType.
exact DummyGen.ArrIntType.
Defined.

(*Why logic*) Definition ArrFloatType : javaType.
exact DummyGen.ArrFloatType.
Defined.

(*Why logic*) Definition ArrBoolType : javaType.
exact DummyGen.ArrBoolType.
Defined.

(*Why logic*) Definition ArrayType : javaType -> javaType.
exact DummyGen.ArrayType.
Defined.

(*Why logic*) Definition ClassType : classId -> javaType.
exact DummyGen.ClassType.
Defined.

(*Why logic*) Definition subType : javaType -> javaType -> Prop.
exact DummyGen.subType.
Defined.

(*Why type*) Definition alloc_table: Set.
exact DummyObj.alloc_table.
Defined.

(*Why logic*) Definition typeof : alloc_table -> value -> javaType -> Prop.
exact DummyObj.typeof.
Defined.

(*Why logic*) Definition instanceof :
  alloc_table -> value -> javaType -> Prop.
exact DummyObj.instanceof.
Defined.


(*Why type*) Definition tag: Set.
exact DummyObj.tag.
Defined.

(*Why logic*) Definition ArrInt : Z -> tag.
exact DummyObj.ArrInt.
Defined.

(*Why logic*) Definition ArrFloat : Z -> tag.
exact DummyObj.ArrFloat.
Defined.

(*Why logic*) Definition ArrBool : Z -> tag.
exact DummyObj.ArrBool.
Defined.

(*Why logic*) Definition ArrObj : Z -> javaType -> tag.
exact DummyObj.ArrObj.
Defined.

(*Why logic*) Definition Obj : classId -> tag.
exact DummyObj.Obj.
Defined.

(*Why logic*) Definition Null : value.
exact DummyObj.Null.
Defined.

(*Why logic*) Definition arraylength : alloc_table -> value -> Z.
exact DummyObj.arraylength.
Defined.

(*Why type*) Definition memory: Set ->Set.
exact DummyObj.memory.
Defined.

(*Why logic*) Definition acc : forall (A1:Set), ((memory) A1) -> value -> A1.
exact DummyObj.acc.
Defined.

(*Why type*) Definition memarray: Set ->Set.
exact DummyObj.memarray.
Defined.

(*Why logic*) Definition array_acc :
  forall (A1:Set), ((memarray) A1) -> value -> Z -> A1.
exact DummyObj.array_acc.
Defined.

(*Why logic*) Definition upd :
  forall (A1:Set), ((memory) A1) -> value -> A1 -> ((memory) A1).
exact DummyObj.upd.
Defined.

(*Why predicate*) Definition is_valid_index  (a:alloc_table) (v:value) (i:Z)
  := 0 <= i /\ i < (arraylength a v).

(*Why logic*) Definition array_upd :
  forall (A1:Set), ((memarray) A1) -> value -> Z -> A1 -> ((memarray) A1).
exact DummyObj.array_upd.
Defined.

(*Why logic*) Definition new_ref : alloc_table -> value.
exact DummyObj.new_ref.
Defined.

(*Why logic*) Definition allocate :
  alloc_table -> value -> tag -> alloc_table.
exact DummyObj.allocate.
Defined.

(*Why logic*) Definition fresh : alloc_table -> value -> Prop.
exact DummyObj.fresh.
Defined.

(*Why predicate*) Definition alive  (a:alloc_table) (v:value)
  := ~(fresh a v).

(*Why logic*) Definition store_extends : alloc_table -> alloc_table -> Prop.
exact DummyObj.store_extends.
Defined.

(*Why type*) Definition mod_loc: Set.
Admitted.

(*Why type*) Definition array_mod_loc: Set.
Admitted.

(*Why logic*) Definition unchanged : value -> mod_loc -> Prop.
Admitted.

(*Why predicate*) Definition modifiable (A162:Set) (h:alloc_table)
  (m:((memory) A162)) (m1:((memory) A162)) (u:mod_loc)
  := (forall (v:value),
      (~(fresh h v) -> ((unchanged v u) -> (acc m v) = (acc m1 v)))).

(*Why logic*) Definition array_unchanged :
  value -> Z -> array_mod_loc -> Prop.
Admitted.

(*Why predicate*) Definition array_modifiable (A163:Set) (h:alloc_table)
  (m:((memarray) A163)) (m1:((memarray) A163)) (u:array_mod_loc)
  := (forall (v:value),
      (forall (n:Z),
       (~(fresh h v) ->
        ((array_unchanged v n u) -> (array_acc m v n) = (array_acc m1 v n))))).

(*Why logic*) Definition nothing_loc : mod_loc.
Admitted.

(*Why logic*) Definition array_nothing_loc : array_mod_loc.
Admitted.

(*Why logic*) Definition everything_loc : mod_loc.
Admitted.

(*Why logic*) Definition value_loc : value -> mod_loc.
Admitted.

(*Why logic*) Definition array_everything_loc : array_mod_loc.
Admitted.

(*Why logic*) Definition inter_loc : mod_loc -> mod_loc -> mod_loc.
Admitted.

(*Why logic*) Definition array_inter_loc :
  array_mod_loc -> array_mod_loc -> array_mod_loc.
Admitted.

(*Why logic*) Definition array_loc : value -> Z -> array_mod_loc.
Admitted.

(*Why logic*) Definition array_sub_loc : value -> Z -> Z -> array_mod_loc.
Admitted.

(*Why logic*) Definition array_all_loc : value -> array_mod_loc.
Admitted.

(*Why logic*) Definition transactionException : classId.
Admitted.

(*Why logic*) Definition ObjectClass : classId.
Admitted.

(*Why axiom*) Lemma negb_def :
  (((negb true) = true <-> ~(true = true))) /\
  (((negb false) = true <-> ~(false = true))).
Admitted.

(*Why axiom*) Lemma orb_def :
  ((((orb true true) = true <-> true = true \/ true = true)) /\
  (((orb true false) = true <-> true = true \/ false = true))) /\
  (((orb false true) = true <-> false = true \/ true = true)) /\
  (((orb false false) = true <-> false = true \/ false = true)).
Admitted.

(*Why axiom*) Lemma andb_def :
  ((((andb true true) = true <-> true = true /\ true = true)) /\
  (((andb true false) = true <-> true = true /\ false = true))) /\
  (((andb false true) = true <-> false = true /\ true = true)) /\
  (((andb false false) = true <-> false = true /\ false = true)).
Admitted.

(*Why axiom*) Lemma true_neq_false : ~(true = false).
Admitted.

(*Why axiom*) Lemma arraylength_always_pos :
  (forall (s:alloc_table), (forall (v:value), 0 <= (arraylength s v))).
Admitted.

(*Why axiom*) Lemma instanceof_typeof :
  (forall (s:alloc_table),
   (forall (v:value),
    (forall (t:javaType), ((typeof s v t) -> (instanceof s v t))))).
Admitted.

(*Why axiom*) Lemma acc_upd :
  forall (A1:Set),
  (forall (m:((memory) A1)),
   (forall (v:value), (forall (w:A1), (acc (upd m v w) v) = w))).
Admitted.

(*Why axiom*) Lemma array_acc_upd :
  forall (A1:Set),
  (forall (m:((memarray) A1)),
   (forall (v:value),
    (forall (n:Z), (forall (w:A1), (array_acc (array_upd m v n w) v n) = w)))).
Admitted.

(*Why axiom*) Lemma acc_upd_other :
  forall (A1:Set),
  (forall (m:((memory) A1)),
   (forall (v1:value),
    (forall (v2:value),
     (forall (w:A1), (~(v1 = v2) -> (acc (upd m v1 w) v2) = (acc m v2)))))).
Admitted.

(*Why axiom*) Lemma array_acc_upd_other :
  forall (A1:Set),
  (forall (m:((memarray) A1)),
   (forall (v1:value),
    (forall (v2:value),
     (forall (n1:Z),
      (forall (n2:Z),
       (forall (w:A1),
        (~(v1 = v2) \/ n1 <> n2 ->
         (array_acc (array_upd m v1 n1 w) v2 n2) = (array_acc m v2 n2)))))))).
Admitted.

(*Why axiom*) Lemma store_extends_refl :
  (forall (s:alloc_table), (store_extends s s)).
Admitted.

(*Why axiom*) Lemma store_extends_trans :
  (forall (s1:alloc_table),
   (forall (s2:alloc_table),
    (forall (s3:alloc_table),
     ((store_extends s1 s2) ->
      ((store_extends s2 s3) -> (store_extends s1 s3)))))).
Admitted.

(*Why axiom*) Lemma instanceof_extends_stable :
  (forall (s1:alloc_table),
   (forall (s2:alloc_table),
    (forall (t:javaType),
     (forall (v:value),
      ((store_extends s1 s2) -> ((instanceof s1 v t) -> (instanceof s2 v t))))))).
Admitted.

(*Why axiom*) Lemma store_extends_fresh :
  (forall (s1:alloc_table),
   (forall (s2:alloc_table),
    (forall (v:value),
     ((store_extends s1 s2) -> ((fresh s2 v) -> (fresh s1 v)))))).
Admitted.

(*Why axiom*) Lemma arraylength_extends_stable :
  (forall (s1:alloc_table),
   (forall (s2:alloc_table),
    (forall (v:value),
     ((store_extends s1 s2) ->
      (~(fresh s1 v) -> (arraylength s1 v) = (arraylength s2 v)))))).
Admitted.

(*Why axiom*) Lemma instanceof_alive :
  (forall (h:alloc_table),
   (forall (t:javaType),
    (forall (v:value), ((instanceof h v t) -> ~(fresh h v))))).
Admitted.

(*Why axiom*) Lemma alive_fresh_diff :
  (forall (t:alloc_table),
   (forall (v1:value),
    (forall (v2:value), ((alive t v1) -> ((fresh t v2) -> ~(v1 = v2)))))).
Admitted.

(*Why axiom*) Lemma unchanged_nothing :
  (forall (v:value), (unchanged v nothing_loc)).
Admitted.

(*Why axiom*) Lemma unchanged_array_nothing :
  (forall (v:value), (forall (n:Z), (array_unchanged v n array_nothing_loc))).
Admitted.

(*Why axiom*) Lemma unchanged_value_loc :
  (forall (v:value),
   (forall (l:value), ((unchanged v (value_loc l)) <-> ~(v = l)))).
Admitted.

(*Why axiom*) Lemma unchanged_inter_loc :
  (forall (v:value),
   (forall (l1:mod_loc),
    (forall (l2:mod_loc),
     ((unchanged v (inter_loc l1 l2)) <->
      ((unchanged v l1) <-> (unchanged v l2)))))).
Admitted.

(*Why axiom*) Lemma unchanged_array_loc :
  (forall (v:value),
   (forall (n:Z),
    (forall (v1:value),
     (forall (z:Z),
      ((array_unchanged v n (array_loc v1 z)) <-> ~(v = v1) \/ z <> n))))).
Admitted.

(*Why axiom*) Lemma unchanged_array_sub_loc :
  (forall (v:value),
   (forall (n:Z),
    (forall (v1:value),
     (forall (z1:Z),
      (forall (z2:Z),
       ((array_unchanged v n (array_sub_loc v1 z1 z2)) <-> ~(v = v1) \/ n <
        z1 \/ z2 < n)))))).
Admitted.

(*Why axiom*) Lemma unchanged_array_all_loc :
  (forall (v:value),
   (forall (n:Z),
    (forall (v1:value),
     ((array_unchanged v n (array_all_loc v1)) <-> ~(v = v1))))).
Admitted.

(*Why axiom*) Lemma unchanged_array_inter_loc :
  (forall (v:value),
   (forall (n:Z),
    (forall (l1:array_mod_loc),
     (forall (l2:array_mod_loc),
      ((array_unchanged v n (array_inter_loc l1 l2)) <->
       (array_unchanged v n l1) /\ (array_unchanged v n l2)))))).
Admitted.

